<template>
  <div>
    <nav class="navbar navbar-expand-lg menu-p">
      <div class="container-fluid">
        <a class="navbar-brand" href="#">{{ brand }}</a>
        <button ref="buttonToggleNavbar" @click="toggleNavbar()" class="navbar-toggler" type="button" data-bs-toggle="collapse" aria-expanded="false" aria-label="Toggle navigation">
          <i class="bi bi-list"></i>
        </button>
        <div class="collapse navbar-collapse" id="navbarSupportedContent">
          <ul v-if="properties.options.length > 0" class="navbar-nav me-auto mb-2 mb-lg-0 subNav">
            <span v-for="(option, index) in properties.options" :key="index">
              <li v-if="option.route != null" class="nav-item">
                <a 
                  class="nav-link" 
                  :class="{active: activeOption != null && activeOption!.name == option.name}"
                  @click="navigateTo(option); hideNavbar();" 
                  href="javascript:void(0)">
                  {{ option.name }}
                </a>
              </li>
              <li v-else class="nav-item dropdown">
                <a 
                  class="nav-link dropdown-toggle"
                  href="#" 
                  role="button" 
                  data-bs-toggle="dropdown"
                  aria-expanded="false"
                >
                  <span style="font-weight: 900;" v-if="activeOption != null && activeOption!.name == option.name">{{ option.name }}</span>
                  <span v-else>{{ option.name }}</span>
                </a>
                <ul class="dropdown-menu">
                  <li v-for="(optionDrop, indexItem) in option.options" :key="indexItem">
                    <span v-if="optionDrop.route == null">
                      <h5 class="dropdown-header">{{ optionDrop.name }}</h5>
                      <li v-for="(optionDropDos, indexItem) in optionDrop.options" :key="indexItem">
                        <a
                          class="dropdown-item"
                          :class="{active: activeOption != null && activeOption!.name == optionDrop.name}"
                          @click="navigateTo(optionDropDos); hideNavbar();"
                          href="javascript:void(0)"
                        >
                          {{ optionDropDos.name }}
                        </a>
                      </li>
                      <hr class="dropdown-divider">
                    </span>
                    <a v-else
                      class="dropdown-item"
                      :class="{active: activeOption != null && activeOption!.name == optionDrop.name}"
                      @click="navigateTo(optionDrop); hideNavbar();"
                      href="javascript:void(0)"
                    >
                      {{ optionDrop.name }}
                    </a>
                  </li>
                </ul>
              </li>
            </span>
          </ul>
        </div>
      </div>
    </nav>
    <slot></slot>

  </div>
</template>

<script setup lang="ts">
import { computed, onMounted, provide, ref, watchEffect } from "vue";
import Collapse from 'bootstrap/js/dist/collapse';
import { Option, navbarKey } from "../../index";
import { type Router } from "vue-router";

class NavBarLevels {
  level_one: Option | null = null;
  level_two: Option | null = null;
}

const properties = withDefaults(defineProps<{
  options: Array<Option>
  title?: String | null,
  router: Router
}>(),{
  title: null,
  option: [],
});

const brand = computed(() => {
  let title = properties.title;
  if( title != null){
    title = title.trim();
  }
  return  title != null ? title : "";
});
const collapseNavbar = ref<Collapse | null>(null);
const activeOption = ref<Option | null>(null);
const selectedOption = ref<Option | null>(null);

provide(navbarKey, selectedOption);

onMounted(() => {
  collapseNavbar.value = new Collapse("#navbarSupportedContent",{toggle: false});
});

watchEffect(() => {
  let currentRouteName = properties.router.currentRoute.value.name;
  if(typeof currentRouteName == "string" && activeOption.value == null ){
    processSelected(currentRouteName);
  }
});

function processSelected(currentRouteName: string | null = null){
  if(currentRouteName != null ){
    let aux = findOptionByNameRecursive(properties.options, currentRouteName);
    if(aux.level_one != null || aux.level_two != null){
      activeOption.value = (aux != null)? aux?.level_one : null;
      selectedOption.value = (aux != null)? ((aux?.level_two != null)? aux?.level_two : aux?.level_one ) : null;
    } else {
      let route_name = properties.router.currentRoute.value.fullPath.split("/",2)[1];
      findOptionByRoute(route_name);
    }
  }
}

function findOptionByNameRecursive(options: any[], routeName: string ): NavBarLevels {
  let BreakException = {};
  let rta: NavBarLevels = new NavBarLevels();
  try {
    options.forEach((option) => {
      if(option.options != null){
        let rtaAux = findOptionByNameRecursive(option.options, routeName);
        if(rtaAux.level_one != null){
          rta.level_one = option;
          rta.level_two = rtaAux.level_one;
        }
      } else if(option.route.name == routeName){
        rta.level_one = option;
        rta.level_two = null;
        throw BreakException;
      }
    });
  } catch (error) {
    if (error !== BreakException) throw error;
  }
  return rta;
}

function findOptionByRoute(route_name: string){
  let BreakException = {};
  let all_routes = properties.router.options.routes.slice(); //  Crea una copia muteable
  
  let rta = all_routes.filter((route) => {
    return route.path.includes(route_name);
  });

  let rta_element: NavBarLevels | null = null;
  try {
    rta.forEach(element => {
      let aux: NavBarLevels | null = null;
      if(element.name !== undefined){
        aux = findOptionByNameRecursive(properties.options, element.name.toString());
      }
      if(aux?.level_one != null || aux?.level_two != null){
        rta_element = aux;
        throw BreakException;
      }
    });
  } catch (error) {
    if (error !== BreakException) throw error;
  }
  
  if (rta_element != null) {
    activeOption.value = (rta_element != null)? rta_element.level_one : null;
    selectedOption.value = (rta_element != null)? ((rta_element.level_two != null)? rta_element.level_two : rta_element.level_one ) : null;
  }

}

function navigateTo(option: Option){
  if(option.route != null){
    properties.router.push(option.route);
  
    // eslint-disable-next-line @typescript-eslint/ban-ts-comment
    // @ts-ignore
    processSelected(option.route.name);
  }
}

function toggleNavbar(){
  collapseNavbar.value!.toggle();
}

function hideNavbar(){
  if (collapseNavbar.value != null) {
    collapseNavbar.value!.hide();
  }
}

// function isArray(item: RouteLocationRaw | Option[]): boolean{
//   return Array.isArray(item);
// }
// function getOptions(options: RouteLocationRaw | Option[]): Option[] {
//   if(!Array.isArray(options)){
//     throw new Error("No se pudo obtener un listado de opciones");
//   }
//   return options;
// }
// function getRoute(route: RouteLocationRaw | Option[]): RouteLocationRaw {
//   if(Array.isArray(route) || route instanceof Option){
//     throw new Error("No se pudo obtener una ruta");
//   }
//   return route;
// }

</script>

<style lang="scss"></style>